KNetwork::KSocksSocketDevice Class Reference

`#include <ksockssocketdevice.h>`

Inheritance diagram for KNetwork::KSocksSocketDevice:

## Public Member Functions

| KSocksSocketDevice (const KSocketBase *=0L)
| KSocksSocketDevice (int fd)
virtual | ~KSocksSocketDevice ()
virtual int | capabilities () const
virtual bool | bind (const KResolverEntry &address)
virtual bool | listen (int backlog)
virtual bool | connect (const KResolverEntry &address)
virtual KSocksSocketDevice * | accept ()
virtual Q_LONG | readBlock (char *data, Q_ULONG maxlen)
virtual Q_LONG | readBlock (char *data, Q_ULONG maxlen, KSocketAddress &from)
virtual Q_LONG | peekBlock (char *data, Q_ULONG maxlen)
virtual Q_LONG | peekBlock (char *data, Q_ULONG maxlen, KSocketAddress &from)
virtual Q_LONG | writeBlock (const char *data, Q_ULONG len)
virtual Q_LONG | writeBlock (const char *data, Q_ULONG len, const KSocketAddress &to)
virtual KSocketAddress | localAddress () const
virtual KSocketAddress | peerAddress () const
virtual KSocketAddress | externalAddress () const
virtual bool | poll (bool *input, bool *output, bool *exception=0L, int timeout=-1, bool *timedout=0L)
Public Member Functions inherited from KNetwork::KSocketDevice
| KSocketDevice (const KSocketBase *=0L)
| KSocketDevice (int fd)
virtual | ~KSocketDevice ()
int | socket () const
virtual bool | setSocketOptions (int opts)
virtual bool | open (int mode)
virtual void | close ()
virtual void | flush ()
virtual bool | create (int family, int type, int protocol)
bool | create (const KResolverEntry &address)
virtual bool | disconnect ()
virtual Q_LONG | bytesAvailable () const
virtual Q_LONG | waitForMore (int msecs, bool *timeout=0L)
QSocketNotifier * | readNotifier () const
QSocketNotifier * | writeNotifier () const
QSocketNotifier * | exceptionNotifier () const
bool | poll (int timeout=-1, bool *timedout=0L)
Public Member Functions inherited from KNetwork::KActiveSocketBase
| KActiveSocketBase ()
virtual | ~KActiveSocketBase ()
virtual Offset | size () const
virtual Offset | at () const
virtual bool | at (Offset)
virtual bool | atEnd () const
virtual int | getch ()
virtual int | putch (int ch)
virtual int | ungetch (int)
Public Member Functions inherited from KNetwork::KSocketBase
| KSocketBase ()
virtual | ~KSocketBase ()
virtual bool | setBlocking (bool enable)
bool | blocking () const
virtual bool | setAddressReuseable (bool enable)
bool | addressReuseable () const
virtual bool | setIPv6Only (bool enable)
bool | isIPv6Only () const
virtual bool | setBroadcast (bool enable)
bool | broadcast () const
KSocketDevice * | socketDevice () const
virtual void | setSocketDevice (KSocketDevice *device)
int | setRequestedCapabilities (int add, int remove=0)
SocketError | error () const
QString | errorString () const
QMutex * | mutex () const
Public Member Functions inherited from KNetwork::KPassiveSocketBase
| KPassiveSocketBase ()
virtual | ~KPassiveSocketBase ()

## Friends

class | KSocketDevice

## Additional Inherited Members

Public Types inherited from KNetwork::KSocketDevice
enum | Capabilities { CanConnectString = 0x01, CanBindString = 0x02, CanNotBind = 0x04, CanNotListen = 0x08, CanMulticast = 0x10, CanNotUseDatagrams = 0x20 }
Public Types inherited from KNetwork::KSocketBase
enum | SocketOptions { Blocking = 0x01, AddressReuseable = 0x02, IPv6Only = 0x04, Keepalive = 0x08, Broadcast = 0x10 }
enum | SocketError { NoError = 0, LookupFailure, AddressInUse, AlreadyCreated, AlreadyBound, AlreadyConnected, NotConnected, NotBound, NotCreated, WouldBlock, ConnectionRefused, ConnectionTimedOut, InProgress, NetFailure, NotSupported, Timeout, UnknownError, RemotelyDisconnected }
Static Public Member Functions inherited from KNetwork::KSocketDevice
static KSocketDevice * | createDefault (KSocketBase *parent)
static KSocketDevice * | createDefault (KSocketBase *parent, int capabilities)
static KSocketDeviceFactoryBase * | setDefaultImpl (KSocketDeviceFactoryBase *factory)
static void | addNewImpl (KSocketDeviceFactoryBase *factory, int capabilities)
Static Public Member Functions inherited from KNetwork::KSocketBase
static QString | errorString (SocketError code)
static bool | isFatalError (int code)
Protected Member Functions inherited from KNetwork::KSocketDevice
| KSocketDevice (bool, const KSocketBase *parent=0L)
virtual QSocketNotifier * | createNotifier (QSocketNotifier::Type type) const
Protected Member Functions inherited from KNetwork::KActiveSocketBase
void | setError (int status, SocketError error)
void | resetError ()
Protected Member Functions inherited from KNetwork::KSocketBase
virtual int | socketOptions () const
bool | hasDevice () const
void | setError (SocketError error)
Protected Attributes inherited from KNetwork::KSocketDevice
int | m_sockfd

## Detailed Description

The low-level class for SOCKS proxying.

This class reimplements several functions from KSocketDevice in order to implement SOCKS support.

This works by using KSocks.

Author
  Thiago Macieira thiag.nosp@m.o.ma.nosp@m.cieir.nosp@m.a@kd.nosp@m.email.nosp@m..net

Warning
  This code is untested!

Definition at line 40 of file ksockssocketdevice.h.

## Constructor & Destructor Documentation

KSocksSocketDevice::KSocksSocketDevice | ( | const KSocketBase * | obj = `0L` | ) |

Constructor.

Definition at line 46 of file ksockssocketdevice.cpp.

KSocksSocketDevice::KSocksSocketDevice | ( | int | fd | ) |

explicit

Construct from a file descriptor.

Definition at line 53 of file ksockssocketdevice.cpp.

KSocksSocketDevice::~KSocksSocketDevice | ( |  | ) |

virtual

Destructor.

Definition at line 60 of file ksockssocketdevice.cpp.

## Member Function Documentation

KSocksSocketDevice * KSocksSocketDevice::accept | ( |  | ) |

virtual

Overrides accepting.

The return type is specialised.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 169 of file ksockssocketdevice.cpp.

bool KSocksSocketDevice::bind | ( | const KResolverEntry & | address | ) |

virtual

Overrides binding.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 73 of file ksockssocketdevice.cpp.

int KSocksSocketDevice::capabilities | ( |  | ) | const

virtual

Sets our capabilities.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 65 of file ksockssocketdevice.cpp.

bool KSocksSocketDevice::connect | ( | const KResolverEntry & | address | ) |

virtual

Overrides connection.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 119 of file ksockssocketdevice.cpp.

KSocketAddress KSocksSocketDevice::externalAddress | ( |  | ) | const

virtual

Overrides getting external address.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 386 of file ksockssocketdevice.cpp.

bool KSocksSocketDevice::listen | ( | int | backlog | ) |

virtual

Overrides listening.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 97 of file ksockssocketdevice.cpp.

KSocketAddress KSocksSocketDevice::localAddress | ( |  | ) | const

virtual

Overrides getting socket address.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 328 of file ksockssocketdevice.cpp.

Q_LONG KSocksSocketDevice::peekBlock | ( | char * | data,
|  | Q_ULONG | maxlen
| ) |  |

virtual

Overrides peeking.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 259 of file ksockssocketdevice.cpp.

Q_LONG KSocksSocketDevice::peekBlock | ( | char * | data,
|  | Q_ULONG | maxlen,
|  | KSocketAddress & | from
| ) |  |

virtual

Peeks the data in the socket and the source address.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 280 of file ksockssocketdevice.cpp.

KSocketAddress KSocksSocketDevice::peerAddress | ( |  | ) | const

virtual

Overrides getting peer address.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 357 of file ksockssocketdevice.cpp.

bool KSocksSocketDevice::poll | ( | bool * | input,
|  | bool * | output,
|  | bool * | exception = `0L`,
|  | int | timeout = `-1`,
|  | bool * | timedout = `0L`
| ) |  |

virtual

Overrides polling.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 392 of file ksockssocketdevice.cpp.

Q_LONG KSocksSocketDevice::readBlock | ( | char * | data,
|  | Q_ULONG | maxlen
| ) |  |

virtual

Overrides reading.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 217 of file ksockssocketdevice.cpp.

Q_LONG KSocksSocketDevice::readBlock | ( | char * | data,
|  | Q_ULONG | maxlen,
|  | KSocketAddress & | from
| ) |  |

virtual

Reads data and the source address from this socket.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 238 of file ksockssocketdevice.cpp.

Q_LONG KSocksSocketDevice::writeBlock | ( | const char * | data,
|  | Q_ULONG | len
| ) |  |

virtual

Overrides writing.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 301 of file ksockssocketdevice.cpp.

Q_LONG KSocksSocketDevice::writeBlock | ( | const char * | data,
|  | Q_ULONG | len,
|  | const KSocketAddress & | to
| ) |  |

virtual

Writes the given data to the given destination address.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 306 of file ksockssocketdevice.cpp.

The documentation for this class was generated from the following files:

- ksockssocketdevice.h
- ksockssocketdevice.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys